#define UNICODE
#define _UNICODE

#include <tchar.h>
#include <windows.h>
#include <time.h>
#include <vector>

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
TCHAR szClassName[ ] = _T("CodeBlocksWindowsApp");

RECT ablak,Client_Rect,kijelzo;
HWND kepernyo;
int ablakszel,ablakmag;
unsigned int jatekospontjai;
const unsigned int idozito=1,alkepvalto=2,jatekosvisszater=3,ellcsinalo=4,jatuzemanyaglevono=5;
bool urhajoletezik=false,levonhatjatuzemanyagot=true;
unsigned char jatekallapota=0, jatekoseletei=3, jatuzemanyaga;

const char* robbanaskep1[225] = { //sz15*m15
            "1","0","0","0","0","0","0","0","0","0","0","0","0","0","1",
            "0","1","0","0","0","0","0","0","0","0","0","0","0","1","0",
            "0","0","1","1","0","0","0","0","0","0","0","1","1","0","0",
            "0","0","0","0","1","0","0","0","0","0","1","0","0","0","0",
            "0","0","0","0","0","1","0","0","0","1","0","0","0","0","0",
            "0","0","0","0","0","0","1","0","1","0","0","0","0","0","0",
            "0","0","0","0","0","0","1","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","1","0","1","0","0","0","0","0","0",
            "0","0","0","0","0","1","0","0","0","1","0","0","0","0","0",
            "0","0","0","0","1","0","0","0","0","0","1","0","0","0","0",
            "0","0","1","1","0","0","0","0","0","0","0","1","1","0","0",
            "0","1","0","0","0","0","0","0","0","0","0","0","0","1","0",
            "1","0","0","0","0","0","0","0","0","0","0","0","0","0","1",
};
const char* robbanaskep2[225] = { //sz15*m15
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","0","0","0","0","0","0","0",
};

const char* urhajokepe1[450] = { //sz30*m15
            "1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0",
            "0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0",
            "0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0",
            "0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0",
            "0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1",
            "0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0",
};

const char* urhajokepe2[450] = {
            "1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","1","0","0","0","0","0","0","0","0","0","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0",
            "0","0","2","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0",
            "0","2","2","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0",
            "2","2","2","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0",
            "0","2","2","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1",
            "0","0","2","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0",
};

const char* urhajokepeelolrol[450] = {
            "0","0","0","0","0","0","0","0","0","0","0","0","0","0","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","0","0","0","0","0","0","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","0","0","0","0","0","0","1","1","0","0","0","0","0","0","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0","0","1","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","1","0","0","0","0","0","0","0","0","0","0","0","0","1","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","1","1","1","0","0","0","0","0","0","0","0","0","1","1","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","0","1","1","1","1","1","1","0","0","0","1","1","1","1","1","0","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0",
            "0","0","0","0","0","0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0","0","0","0","0","0",
            "0","0","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","0","0",
            "1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1","1",
};

HBITMAP robbkep1() {
    HBITMAP robbkep;
    HDC hdcKepnek;
    robbkep = CreateBitmap(15, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, robbkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<225; i++) {
        if (i % 15 == 0) {xkoord = 0; ykoord += 1;}
        else if (robbanaskep1[i]=="0") {xkoord += 1;}
        else {SetPixel(hdcKepnek,xkoord,ykoord,RGB(255,255,255)); xkoord += 1;};
    };
    DeleteDC(hdcKepnek);
    return robbkep;
};

HBITMAP robbkep2() {
    HBITMAP robbkep;
    HDC hdcKepnek;
    robbkep = CreateBitmap(15, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, robbkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<225; i++) {
        if (i % 15 == 0) {xkoord = 0; ykoord += 1;}
        else if (robbanaskep2[i]=="0") {xkoord += 1;}
        else {SetPixel(hdcKepnek,xkoord,ykoord,RGB(255,255,255)); xkoord += 1;};
    };
    DeleteDC(hdcKepnek);
    return robbkep;
};

HBITMAP jaturhjobbra1() {
    HBITMAP urhjobbkep;
    HDC hdcKepnek;
    urhjobbkep = CreateBitmap(30, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, urhjobbkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<450; i++) {
        if (i % 30 == 0) {xkoord = 0; ykoord += 1;}
        else if (urhajokepe1[i]=="0") {xkoord += 1;}
        else {SetPixel(hdcKepnek,xkoord,ykoord,RGB(255,255,255)); xkoord += 1;};
    };
    DeleteDC(hdcKepnek);
    return urhjobbkep;
};

HBITMAP jaturhbalra1() {
    HBITMAP urhbalkep;
    HDC hdcKepnek;
    urhbalkep = CreateBitmap(30, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, urhbalkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<450; i++) {
        if (i % 30 == 0) {xkoord = 0; ykoord += 1;}
        else if (urhajokepe1[i]=="0") {xkoord -= 1;}
        else {SetPixel(hdcKepnek,xkoord+30,ykoord,RGB(255,255,255)); xkoord -= 1;};
    };
    DeleteDC(hdcKepnek);
    return urhbalkep;
};

HBITMAP jaturhjobbra2() {
    HBITMAP urhjobbkep;
    HDC hdcKepnek;
    urhjobbkep = CreateBitmap(30, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, urhjobbkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<450; i++) {
        if (i % 30 == 0) {xkoord = 0; ykoord += 1;}
        else if (urhajokepe2[i]=="0") {xkoord += 1;}
        else if (urhajokepe2[i]=="2") {SetPixel(hdcKepnek,xkoord,ykoord,RGB(255,242,0)); xkoord += 1;}
        else {SetPixel(hdcKepnek,xkoord,ykoord,RGB(255,255,255)); xkoord += 1;};
    };
    DeleteDC(hdcKepnek);
    return urhjobbkep;
};

HBITMAP jaturhbalra2() {
    HBITMAP urhbalkep;
    HDC hdcKepnek;
    urhbalkep = CreateBitmap(30, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, urhbalkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<450; i++) {
        if (i % 30 == 0) {xkoord = 0; ykoord += 1;}
        else if (urhajokepe2[i]=="0") {xkoord -= 1;}
        else if (urhajokepe2[i]=="2") {SetPixel(hdcKepnek,xkoord+30,ykoord,RGB(255,242,0)); xkoord -= 1;}
        else {SetPixel(hdcKepnek,xkoord+30,ykoord,RGB(255,255,255)); xkoord -= 1;};
    };
    DeleteDC(hdcKepnek);
    return urhbalkep;
};

HBITMAP jaturhelolrol() {
    HBITMAP urhelolrolkep;
    HDC hdcKepnek;
    urhelolrolkep = CreateBitmap(30, 15, 1, 1, NULL);
    hdcKepnek = CreateCompatibleDC(0);
    SelectObject(hdcKepnek, urhelolrolkep);
    int xkoord=0,ykoord=0;
    for (int i=0; i<450; i++) {
        if (i % 30 == 0) {xkoord = 0; ykoord += 1;}
        else if (urhajokepeelolrol[i]=="0") {xkoord -= 1;}
        else {SetPixel(hdcKepnek,xkoord+30,ykoord,RGB(255,255,255)); xkoord -= 1;};
    };
    DeleteDC(hdcKepnek);
    return urhelolrolkep;
};

class Robbanas {
    public:
        Robbanas(int xh, int yh) {
            xhely = xh;
            yhely = yh;
            if (rand()%2==1) {
                alkepe = 1;
            }
            else {
                alkepe = 2;
            };
            letezikido = 200;
            alkepvaltido = 10;
        };
        void kirajzol(HDC grafkez, HDC kepkez, HBITMAP kepe) {
            SelectObject(kepkez, kepe);
            BitBlt(grafkez, xhely, yhely, 15, 15, kepkez, 0, 0, SRCPAINT);
        };
        int xhely, yhely, alkepe, letezikido, alkepvaltido;
};

std::vector<Robbanas> robbanasok;

class Ellenseg {
    public:
        Ellenseg(int xhelye, int yhelye, unsigned char fajtaja, unsigned char irany, int kszel, int kmag) {
            xh = xhelye;
            yh = yhelye;
            fajta = fajtaja;
            switch (fajta) {
                case 0: alkepdb = 1; //UFO
                    pontoter = 15;
                break;
                case 1:
                case 2: alkepdb = 2; //Aknatelept UFO s medza
                    pontoter = 10;
                break;
            };
            alkepe = 1;
            alkepvaltido = 50;
            iranya = irany;
            kepszel = kszel;
            kepmag = kmag;
        };
        void kirajzol(HDC grafkez, HDC kepkez, int kepszel, int kepmag, HBITMAP alkep, HBITMAP kepmaszk) {
            SelectObject(kepkez, kepmaszk);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCAND);
            SelectObject(kepkez, alkep);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCPAINT);
        };
        int xh,yh,kepszel,kepmag;
        unsigned char fajta,alkepdb,alkepe,alkepvaltido,iranya,pontoter;
};

std::vector<Ellenseg> ellensegek;

class Cucc {
    public:
        Cucc(int xhelye, int yhelye, unsigned char fajtaja, unsigned char irany, int kszel, int kmag) {
            xh = xhelye;
            yh = yhelye;
            fajta = fajtaja;
            iranya = irany;
            kepszel = kszel;
            kepmag = kmag;
        };
        void kirajzol(HDC grafkez, HDC kepkez, int kepszel, int kepmag, HBITMAP a_kepe, HBITMAP kepmaszk) {
            SelectObject(kepkez, kepmaszk);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCAND);
            SelectObject(kepkez, a_kepe);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCPAINT);
        };
        int xh,yh,kepszel,kepmag;
        unsigned char iranya,fajta;
};

std::vector<Cucc> cuccok;

class JatekosUrhajoja {
    public:
        JatekosUrhajoja(int xh, int yh) {
            xhely = xh;
            yhely = yh;
            iranya = 0;
            alkepe = 1;
            mitcsinal = 0; //Semmit.
        };
        void kirajzol(HDC grafkez, HDC kepkez, HBITMAP kepe) {
            SelectObject(kepkez, kepe);
            BitBlt(grafkez, xhely, yhely, 30, 15, kepkez, 0, 0, SRCPAINT);
        };
        int xhely, yhely, iranya, alkepe, mitcsinal;
};

class JatUrhLov {
    public:
        JatUrhLov(int xh, int yh, int ir) {
            xhely = xh;
            yhely = yh;
            iranya = ir;
        };
        void kirajzol(HDC grafkez) {
            Rectangle(grafkez,xhely,yhely,xhely+50,yhely+3);
        };
        int xhely,yhely,iranya;
};

std::vector<JatUrhLov> jatlovedekei;

class Csillag {
    public:
        Csillag(int xh, int yh) {
            xhely = xh;
            yhely = yh;
            fajta = rand()%2;
            szin = rand()%2;
            xseb = rand()%8+1;
            if (rand()%2==0) xseb *= -1;
            yseb = rand()%8+1;
            if (rand()%2==0) yseb *= -1;
        };
        void kirajzol(HDC grafkez) {
            if (fajta == 0) { //Csak egy pont:
                if (szin == 0)
                    SetPixel(grafkez,xhely,yhely,RGB(255,255,255));
                else
                    SetPixel(grafkez,xhely,yhely,RGB(255,255,0));
            } else { //+ alak:
                if (szin == 0) {
                    SetPixel(grafkez,xhely,yhely,RGB(255,255,255)); //Kzepe
                    SetPixel(grafkez,xhely-1,yhely,RGB(255,255,255)); //Kzeptl balra
                    SetPixel(grafkez,xhely+1,yhely,RGB(255,255,255)); //Kzeptl jobbra
                    SetPixel(grafkez,xhely,yhely-1,RGB(255,255,255)); //Kzepe fltt
                    SetPixel(grafkez,xhely,yhely+1,RGB(255,255,255)); //Kzepe alatt
                }
                else {
                    SetPixel(grafkez,xhely,yhely,RGB(255,255,0)); //Kzepe
                    SetPixel(grafkez,xhely-1,yhely,RGB(255,255,0)); //Kzeptl balra
                    SetPixel(grafkez,xhely+1,yhely,RGB(255,255,0)); //Kzeptl jobbra
                    SetPixel(grafkez,xhely,yhely-1,RGB(255,255,0)); //Kzepe fltt
                    SetPixel(grafkez,xhely,yhely+1,RGB(255,255,0)); //Kzepe alatt
                };
            };
        };
        int xhely,yhely;
        unsigned char fajta,szin;
        char xseb,yseb;
};

std::vector<Csillag> csillagok;

class AknakKeppel {
    public:
        AknakKeppel(int xhelye, int yhelye, int kszel, int kmag) {
            xh = xhelye;
            yh = yhelye;
            kepszel = kszel;
            kepmag = kmag;
        };
        void kirajzol(HDC grafkez, HDC kepkez, int kepszel, int kepmag, HBITMAP aknakep, HBITMAP kepmaszk) {
            SelectObject(kepkez, kepmaszk);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCAND);
            SelectObject(kepkez, aknakep);
            BitBlt(grafkez, xh, yh, kepszel, kepmag, kepkez, 0, 0, SRCPAINT);
        };
        int xh,yh,kepszel,kepmag;
};

std::vector<AknakKeppel> aknak;

bool uresezahely(int xhely, int yhely, int index, int aknasz, int aknam)
{
    for (int e=0; e<ellensegek.size(); e++) {
       if (e!=index && xhely < ellensegek[e].xh + ellensegek[e].kepszel &&
            xhely + aknasz > ellensegek[e].xh &&
            yhely < ellensegek[e].yh + ellensegek[e].kepmag &&
            aknam + yhely > ellensegek[e].yh) return false;
    };
    for (int a=0; a<aknak.size(); a++) {
        if (xhely < aknak[a].xh + aknak[a].kepszel &&
            xhely + aknasz > aknak[a].xh &&
            yhely < aknak[a].yh + aknak[a].kepmag &&
            aknam + yhely > aknak[a].yh) return false;
    };
    return true;
};

void palyatorles()
{
    aknak.clear();
    cuccok.clear();
    csillagok.clear();
    ellensegek.clear();
    jatlovedekei.clear();
    robbanasok.clear();
};

HBITMAP CreateBitmapMask(HBITMAP hbmColour, COLORREF crTransparent)
{
    HDC hdcMem, hdcMem2;
    HBITMAP hbmMask;
    BITMAP bm;

    //Monokrm (1 bites) maszk bitkp ksztse.
    GetObject(hbmColour, sizeof(BITMAP), &bm);
    hbmMask = CreateBitmap(bm.bmWidth, bm.bmHeight, 1, 1, NULL);

    //Nhny HDC ksztse, amelyek sszefrhetk a kijelz illesztprogramjval.
    hdcMem = CreateCompatibleDC(0);
    hdcMem2 = CreateCompatibleDC(0);

    SelectObject(hdcMem, hbmColour);
    SelectObject(hdcMem2, hbmMask);

    //A sznes kp httrsznnek belltsa arra a sznre, amit tltsznak akarsz.
    SetBkColor(hdcMem, crTransparent);

    //A bitek msolsa a sznes kprl a Fekete-Fehr maszkra... minden fehren vgzdik a httrsznnel,
    //minden egyb pedig feketn... Csak amit akartunk.
    BitBlt(hdcMem2, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY);

    //Fogjuk j maszkunkat, s felhasznljuk arra, hogy a httrsznt fordtsa feketre az eredeti sznes kpnkben,
    //gy az ttetszsgi hats megfelelen fog mkdni.
    BitBlt(hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem2, 0, 0, SRCINVERT);

    //Tisztogats.
    DeleteDC(hdcMem);
    DeleteDC(hdcMem2);

    return hbmMask;
};

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default colour as the background of the window */
    wincl.hbrBackground = NULL;// CreateSolidBrush(RGB(0,0,0));
    //wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    kepernyo = GetDesktopWindow();
    GetWindowRect (kepernyo, &kijelzo);
    ablakszel = kijelzo.right-kijelzo.left;
    ablakmag = kijelzo.bottom-kijelzo.top;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           _T("Nyil gombok: mozgas, CTRL: loves, ESC: kilepes"),       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           ablakszel,                 /* The programs width */
           ablakmag,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nCmdShow);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}

JatekosUrhajoja jatekos(ablakszel/2,ablakmag/2);

/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HDC grafikakezelo,kepkezelo;
    PAINTSTRUCT ps;
    static HBITMAP eletkepe=NULL,eletkepemaszk=NULL,uatartkepe=NULL,uatartkepemaszk=NULL,aknakkepe=NULL,aknakkepemaszk=NULL,ufokepe=NULL,ufokepemaszk=NULL,aknasufokepe1=NULL,aknasufokepemaszk1=NULL,aknasufokepe2=NULL,aknasufokepemaszk2=NULL,meduzakepe1=NULL,meduzakepemaszk1=NULL,meduzakepe2=NULL,meduzakepemaszk2=NULL,jaturhbalra1kep=NULL,jaturhjobbra1kep=NULL,jaturhbalra2kep=NULL,jaturhjobbra2kep=NULL,jaturhelolrolkep=NULL,robb1kep=NULL,robb2kep=NULL;
    BITMAP bitmapkep,ufobitmapkep,aknasufobitmapkep,meduzabitmapkep,eletbitmapkep,uatartbitmapkep;

    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
            srand(time(NULL));
            SetTimer(hwnd,idozito,25,NULL);

            jaturhbalra1kep = jaturhbalra1();
            jaturhjobbra1kep = jaturhjobbra1();
            jaturhbalra2kep = jaturhbalra2();
            jaturhjobbra2kep = jaturhjobbra2();
            jaturhelolrolkep = jaturhelolrol();

            robb1kep = robbkep1();
            robb2kep = robbkep2();

            //A kpek betltse:
            aknakkepe = static_cast<HBITMAP>(LoadImageA(NULL, "akna.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            aknakkepemaszk = CreateBitmapMask(aknakkepe, RGB(63,72,204)); //Az indigkk httrszne lesz ttetsz.
            GetObject(aknakkepe, sizeof(bitmapkep), &bitmapkep);
            eletkepe = static_cast<HBITMAP>(LoadImageA(NULL, "pluszelet.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            eletkepemaszk = CreateBitmapMask(eletkepe, RGB(63,72,204));
            GetObject(eletkepe, sizeof(eletbitmapkep), &eletbitmapkep);
            uatartkepe = static_cast<HBITMAP>(LoadImageA(NULL, "pluszuzemanyag.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            uatartkepemaszk = CreateBitmapMask(uatartkepe, RGB(63,72,204));
            GetObject(uatartkepe, sizeof(uatartbitmapkep), &uatartbitmapkep);
            ufokepe = static_cast<HBITMAP>(LoadImageA(NULL, "ufo.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            ufokepemaszk = CreateBitmapMask(ufokepe, RGB(63,72,204));
            GetObject(ufokepe, sizeof(ufobitmapkep), &ufobitmapkep);
            aknasufokepe1 = static_cast<HBITMAP>(LoadImageA(NULL, "aknazoufo1.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            aknasufokepemaszk1 = CreateBitmapMask(aknasufokepe1, RGB(63,72,204));
            aknasufokepe2 = static_cast<HBITMAP>(LoadImageA(NULL, "aknazoufo2.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            aknasufokepemaszk2 = CreateBitmapMask(aknasufokepe2, RGB(63,72,204));
            GetObject(aknasufokepe1, sizeof(aknasufobitmapkep), &aknasufobitmapkep);
            meduzakepe1 = static_cast<HBITMAP>(LoadImageA(NULL, "meduza1.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            meduzakepemaszk1 = CreateBitmapMask(meduzakepe1, RGB(63,72,204));
            meduzakepe2 = static_cast<HBITMAP>(LoadImageA(NULL, "meduza2.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
            meduzakepemaszk2 = CreateBitmapMask(meduzakepe2, RGB(63,72,204));
            GetObject(meduzakepe1, sizeof(meduzabitmapkep), &meduzabitmapkep);
            for (int i=0; i<22; i++)
            {
                csillagok.push_back(Csillag(ablakszel/2,ablakmag/2));
            };
        break;
        case WM_PAINT:
            grafikakezelo = BeginPaint(hwnd, &ps);
            kepkezelo = CreateCompatibleDC(grafikakezelo);

            HDC Memhdc;
            HBITMAP Membitmap;
            Memhdc = CreateCompatibleDC(grafikakezelo);
            Membitmap = CreateCompatibleBitmap(grafikakezelo, ablakszel, ablakmag);
            SelectObject(Memhdc, Membitmap);

            if (jatekallapota == 0) {
                    for (int cs=0; cs<csillagok.size(); cs++) {
                        csillagok[cs].xhely += csillagok[cs].xseb;
                        csillagok[cs].yhely += csillagok[cs].yseb;

                        if (csillagok[cs].xhely<0 || csillagok[cs].xhely>ablakszel || csillagok[cs].yhely<0 || csillagok[cs].yhely>ablakmag) {
                            csillagok[cs].xhely = ablakszel/2;
                            csillagok[cs].yhely = ablakmag/2;
                            csillagok[cs].xseb = rand()%8+1;
                            if (rand()%2==0) csillagok[cs].xseb *= -1;
                            csillagok[cs].yseb = rand()%8+1;
                            if (rand()%2==0) csillagok[cs].yseb *= -1;
                        };
                        csillagok[cs].kirajzol(Memhdc);
                    };
                    static HFONT betuk = CreateFont(28, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_OUTLINE_PRECIS,
                        CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, VARIABLE_PITCH, TEXT("Asimov"));
                    SelectObject(Memhdc, betuk);
                    SIZE sz;
                    static const WCHAR cimszoveg[]= L"SPACE ZONE v.: 1.2";
                    GetTextExtentPoint32(Memhdc,cimszoveg,wcslen(cimszoveg),&sz);
                    TextOut(Memhdc, ablakszel/2-sz.cx/2,4,cimszoveg,wcslen(cimszoveg));
                    static const WCHAR szoveg1[]= L"Nyomj le egy gombot a kezdshez!";
                    GetTextExtentPoint32(Memhdc,szoveg1,wcslen(szoveg1),&sz);
                    TextOut(Memhdc, ablakszel/2-sz.cx/2,40,szoveg1,wcslen(szoveg1));
                    static const WCHAR szoveg2[]= L"Ksztette: Ipacs Tams (2022)";
                    GetTextExtentPoint32(Memhdc,szoveg2,wcslen(szoveg2),&sz);
                    TextOut(Memhdc, ablakszel/2-sz.cx/2,ablakmag-280,szoveg2,wcslen(szoveg2));
            }
            else {
                for (int cs=0; cs<csillagok.size(); cs++) {
                    csillagok[cs].kirajzol(Memhdc);
                };

                for (int i=0; i<jatlovedekei.size(); i++) {
                    if (jatlovedekei[i].xhely<1 || jatlovedekei[i].xhely>ablakszel) {
                        jatlovedekei.erase(jatlovedekei.begin()+i);
                    }
                    else {
                        bool utkozott = false;

                        if (jatlovedekei[i].iranya == 0) {
                            jatlovedekei[i].xhely+=8;
                        }
                        else {
                            jatlovedekei[i].xhely-=8;
                        };
                        for (int j=0; j<aknak.size(); j++) {
                            if (jatlovedekei[i].xhely < aknak[j].xh + aknak[j].kepszel &&
                               jatlovedekei[i].xhely + 10 > aknak[j].xh &&
                               jatlovedekei[i].yhely < aknak[j].yh + aknak[j].kepmag &&
                               10 + jatlovedekei[i].yhely > aknak[j].yh) {
                                    jatlovedekei.erase(jatlovedekei.begin()+i);
                                    jatekospontjai += 5;
                                    robbanasok.push_back(Robbanas(aknak[j].xh-7,aknak[j].yh-7));
                                    robbanasok.push_back(Robbanas(aknak[j].xh+aknak[j].kepszel-7,aknak[j].yh-7));
                                    robbanasok.push_back(Robbanas(aknak[j].xh+aknak[j].kepszel/2,aknak[j].yh+aknak[j].kepmag/2));
                                    robbanasok.push_back(Robbanas(aknak[j].xh-7,aknak[j].yh+aknak[j].kepmag-7));
                                    robbanasok.push_back(Robbanas(aknak[j].xh+aknak[j].kepszel-7,aknak[j].yh+aknak[j].kepmag-7));
                                    aknak.erase(aknak.begin()+j);
                                    PlaySound(TEXT("utkozeshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                    utkozott = true;
                                    break;
                            };
                        };
                        if (utkozott==false) {
                            for (int j=0; j<ellensegek.size(); j++) {
                                if (jatlovedekei[i].xhely < ellensegek[j].xh + ellensegek[j].kepszel &&
                                   jatlovedekei[i].xhely + 10 > ellensegek[j].xh &&
                                   jatlovedekei[i].yhely < ellensegek[j].yh + ellensegek[j].kepmag &&
                                   10 + jatlovedekei[i].yhely > ellensegek[j].yh) {
                                        jatlovedekei.erase(jatlovedekei.begin()+i);
                                        robbanasok.push_back(Robbanas(ellensegek[j].xh-7,ellensegek[j].yh-7));
                                        robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel-7,ellensegek[j].yh-7));
                                        robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel/2,ellensegek[j].yh+ellensegek[j].kepmag/2));
                                        robbanasok.push_back(Robbanas(ellensegek[j].xh-7,ellensegek[j].yh+ellensegek[j].kepmag-7));
                                        robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel-7,ellensegek[j].yh+ellensegek[j].kepmag-7));
                                        switch (ellensegek[j].fajta) {
                                            case 0:
                                            case 1:
                                                PlaySound(TEXT("utkozeshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                                if (rand()%5 == 1) {
                                                    GetObject(uatartkepe, sizeof(uatartbitmapkep), &uatartbitmapkep);
                                                    cuccok.push_back(Cucc(ellensegek[j].xh,ellensegek[j].yh,1,ellensegek[j].iranya,uatartbitmapkep.bmWidth,uatartbitmapkep.bmHeight));
                                                };
                                            break;
                                            case 2:
                                                PlaySound(TEXT("placcshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                                if (rand()%5 == 1) {
                                                    GetObject(eletkepe, sizeof(eletbitmapkep), &eletbitmapkep);
                                                    cuccok.push_back(Cucc(ellensegek[j].xh,ellensegek[j].yh,0,ellensegek[j].iranya,eletbitmapkep.bmWidth,eletbitmapkep.bmHeight));
                                                };
                                            break;
                                        };
                                        jatekospontjai += ellensegek[j].pontoter;
                                        ellensegek.erase(ellensegek.begin()+j);
                                        utkozott = true;
                                        break;
                                };
                            };
                        };
                        if (utkozott==false) jatlovedekei[i].kirajzol(Memhdc);
                    };
                };

                for (int c=0; c<cuccok.size(); c++) {
                    if (cuccok[c].iranya == 0) {
                        cuccok[c].xh+=2;
                    }
                    else {
                        cuccok[c].xh-=2;
                    };
                    if (cuccok[c].xh+cuccok[c].kepszel<1 || cuccok[c].xh>ablakszel) {
                        cuccok.erase(cuccok.begin()+c);
                    }
                    else {
                        switch (cuccok[c].fajta) {
                            case 0: //let:
                                cuccok[c].kirajzol(Memhdc, kepkezelo, cuccok[c].kepszel, cuccok[c].kepmag, eletkepe, eletkepemaszk);
                            break;
                            case 1: //zemanyag tartly:
                                cuccok[c].kirajzol(Memhdc, kepkezelo, cuccok[c].kepszel, cuccok[c].kepmag, uatartkepe, uatartkepemaszk);
                            break;
                        };
                    };
                };

                for (int i=0; i<ellensegek.size(); i++) {
                    if ((ellensegek[i].xh+ellensegek[i].kepszel<1 && ellensegek[i].iranya == 1) || (ellensegek[i].xh>ablakszel && ellensegek[i].iranya == 0)) {
                        ellensegek.erase(ellensegek.begin()+i);
                    }
                    else {
                        switch (ellensegek[i].fajta) {
                            case 0: //UFO:
                                if (ellensegek[i].iranya == 0) {
                                    ellensegek[i].xh+=4;
                                }
                                else {
                                    ellensegek[i].xh-=4;
                                };
                                ellensegek[i].kirajzol(Memhdc, kepkezelo, ellensegek[i].kepszel, ellensegek[i].kepmag, ufokepe, ufokepemaszk);
                            break;
                            case 1: //Aknatelept UFO:
                                if (ellensegek[i].iranya == 0) {
                                    ellensegek[i].xh+=2;
                                }
                                else {
                                    ellensegek[i].xh-=2;
                                };
                                GetObject(aknakkepe, sizeof(bitmapkep), &bitmapkep);
                                if (ellensegek[i].xh>1 && ellensegek[i].xh+ellensegek[i].kepszel<ablakszel && rand()%100==1 && uresezahely(ellensegek[i].xh+ellensegek[i].kepszel/2,ellensegek[i].yh+ellensegek[i].kepmag,i,bitmapkep.bmWidth,bitmapkep.bmHeight)==true) {
                                    aknak.push_back(AknakKeppel(ellensegek[i].xh+ellensegek[i].kepszel/2,ellensegek[i].yh+ellensegek[i].kepmag,bitmapkep.bmWidth,bitmapkep.bmHeight));
                                };
                                ellensegek[i].alkepvaltido -= 1;
                                if (ellensegek[i].alkepvaltido < 1) {
                                    ellensegek[i].alkepvaltido = 50;
                                    if (ellensegek[i].alkepe == 1) {
                                        ellensegek[i].alkepe = 2;
                                    }
                                    else ellensegek[i].alkepe = 1;
                                };
                                if (ellensegek[i].alkepe == 1) {
                                    ellensegek[i].kirajzol(Memhdc, kepkezelo, ellensegek[i].kepszel, ellensegek[i].kepmag, aknasufokepe2, aknasufokepemaszk2);
                                }
                                else {
                                    ellensegek[i].kirajzol(Memhdc, kepkezelo, ellensegek[i].kepszel, ellensegek[i].kepmag, aknasufokepe1, aknasufokepemaszk1);
                                };
                            break;
                            case 2: //Medza:
                                if (ellensegek[i].iranya == 0) {
                                    ellensegek[i].xh+=2;
                                }
                                else {
                                    ellensegek[i].xh-=2;
                                };
                                ellensegek[i].alkepvaltido -= 1;
                                if (ellensegek[i].alkepvaltido < 1) {
                                    ellensegek[i].alkepvaltido = 50;
                                    if (ellensegek[i].alkepe == 1) {
                                        ellensegek[i].alkepe = 2;
                                    }
                                    else ellensegek[i].alkepe = 1;
                                };
                                if (ellensegek[i].alkepe == 1) {
                                    ellensegek[i].kirajzol(Memhdc, kepkezelo, ellensegek[i].kepszel, ellensegek[i].kepmag, meduzakepe2, meduzakepemaszk2);
                                }
                                else {
                                    ellensegek[i].kirajzol(Memhdc, kepkezelo, ellensegek[i].kepszel, ellensegek[i].kepmag, meduzakepe1, meduzakepemaszk1);
                                };
                            break;
                        };
                    };
                };

                for (int i=0; i<aknak.size(); i++) {
                    if (urhajoletezik == true) {
                        if (jatekos.xhely < aknak[i].xh + aknak[i].kepszel &&
                               jatekos.xhely + 30 > aknak[i].xh &&
                               jatekos.yhely < aknak[i].yh + aknak[i].kepmag &&
                               15 + jatekos.yhely > aknak[i].yh) {
                                    robbanasok.push_back(Robbanas(jatekos.xhely-7,jatekos.yhely-7));
                                    robbanasok.push_back(Robbanas(jatekos.xhely+37,jatekos.yhely-7));
                                    robbanasok.push_back(Robbanas(jatekos.xhely+15,jatekos.yhely+15));
                                    robbanasok.push_back(Robbanas(jatekos.xhely-7,jatekos.yhely+22));
                                    robbanasok.push_back(Robbanas(jatekos.xhely+37,jatekos.yhely+22));
                                    urhajoletezik = false;
                                    robbanasok.push_back(Robbanas(aknak[i].xh-7,aknak[i].yh-7));
                                    robbanasok.push_back(Robbanas(aknak[i].xh+aknak[i].kepszel-7,aknak[i].yh-7));
                                    robbanasok.push_back(Robbanas(aknak[i].xh+aknak[i].kepszel/2,aknak[i].yh+aknak[i].kepmag/2));
                                    robbanasok.push_back(Robbanas(aknak[i].xh-7,aknak[i].yh+aknak[i].kepmag-7));
                                    robbanasok.push_back(Robbanas(aknak[i].xh+aknak[i].kepszel-7,aknak[i].yh+aknak[i].kepmag-7));
                                    aknak.erase(aknak.begin()+i);
                                    jatekoseletei -= 1;
                                    SetTimer(hwnd,jatekosvisszater,2000,NULL);
                                    PlaySound(TEXT("utkozeshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                            };
                    };
                    aknak[i].kirajzol(Memhdc, kepkezelo, aknak[i].kepszel, aknak[i].kepmag, aknakkepe, aknakkepemaszk);
                };

                if (urhajoletezik == true) {
                    if (jatekos.alkepe == 0) {
                            jatekos.kirajzol(Memhdc, kepkezelo, jaturhelolrolkep);
                    }
                    else if (jatekos.iranya == 0) {
                        if (jatekos.alkepe == 1) {
                            jatekos.kirajzol(Memhdc, kepkezelo, jaturhjobbra1kep);
                        }
                        else {
                            jatekos.kirajzol(Memhdc, kepkezelo, jaturhjobbra2kep);
                        };
                    }
                    else {
                        if (jatekos.alkepe == 1) {
                            jatekos.kirajzol(Memhdc, kepkezelo, jaturhbalra1kep);
                        }
                        else {
                            jatekos.kirajzol(Memhdc, kepkezelo, jaturhbalra2kep);
                        };
                    };
                    for (int j=0; j<ellensegek.size(); j++) {
                        if (jatekos.xhely < ellensegek[j].xh + ellensegek[j].kepszel &&
                           jatekos.xhely + 10 > ellensegek[j].xh &&
                           jatekos.yhely < ellensegek[j].yh + ellensegek[j].kepmag &&
                           10 + jatekos.yhely > ellensegek[j].yh) {
                                urhajoletezik = false;
                                robbanasok.push_back(Robbanas(ellensegek[j].xh-7,ellensegek[j].yh-7));
                                robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel-7,ellensegek[j].yh-7));
                                robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel/2,ellensegek[j].yh+ellensegek[j].kepmag/2));
                                robbanasok.push_back(Robbanas(ellensegek[j].xh-7,ellensegek[j].yh+ellensegek[j].kepmag-7));
                                robbanasok.push_back(Robbanas(ellensegek[j].xh+ellensegek[j].kepszel-7,ellensegek[j].yh+ellensegek[j].kepmag-7));
                                ellensegek.erase(ellensegek.begin()+j);
                                jatekoseletei -= 1;
                                SetTimer(hwnd,jatekosvisszater,2000,NULL);
                                switch (ellensegek[j].fajta) {
                                    case 0:
                                    case 1:
                                        PlaySound(TEXT("utkozeshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                    break;
                                    case 2:
                                        PlaySound(TEXT("placcshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                    break;
                                };
                        };
                    };
                    for (int c=0; c<cuccok.size(); c++) {
                        if (jatekos.xhely < cuccok[c].xh + cuccok[c].kepszel &&
                           jatekos.xhely + 10 > cuccok[c].xh &&
                           jatekos.yhely < cuccok[c].yh + cuccok[c].kepmag &&
                           10 + jatekos.yhely > cuccok[c].yh) {
                                switch (cuccok[c].fajta) {
                                    case 0: if (jatekoseletei+1 < 255) jatekoseletei += 1;
                                            else jatekospontjai += 5;
                                    break;
                                    case 1: if (jatuzemanyaga+10 <= 100) jatuzemanyaga += 10;
                                            else jatekospontjai += 5;
                                    break;
                                };
                                PlaySound(TEXT("felveszhang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                                cuccok.erase(cuccok.begin()+c);
                        };
                    };
                };

                for (int i=0; i<robbanasok.size(); i++) {
                    robbanasok[i].letezikido -= 1;
                    if (robbanasok[i].letezikido<1) {
                        robbanasok.erase(robbanasok.begin()+i);
                    }
                    else {
                        HBITMAP az_alkepe;

                        if (robbanasok[i].letezikido % robbanasok[i].alkepvaltido == 0) {
                            if (robbanasok[i].alkepe == 1) {
                                robbanasok[i].alkepe = 2;
                                az_alkepe = robb2kep;
                            }
                            else {
                                robbanasok[i].alkepe = 1;
                                az_alkepe = robb1kep;
                            };
                        }
                        else {
                            if (robbanasok[i].alkepe == 1) {
                                az_alkepe = robb1kep;
                            }
                            else {
                                az_alkepe = robb2kep;
                            };
                        };
                        robbanasok[i].kirajzol(Memhdc, kepkezelo, az_alkepe);
                    };
                };

                DeleteDC(kepkezelo);

                static const WCHAR eletszoveg[]= L"LETEID:";
                TextOut(Memhdc,4,4,eletszoveg,wcslen(eletszoveg));
                WCHAR jateleteidb[3];
                _itow(jatekoseletei,jateleteidb,10);
                TextOut(Memhdc,4,4+28,jateleteidb,wcslen(jateleteidb));
                static const WCHAR pontszoveg[]= L"PONTJAID:";
                TextOut(Memhdc,80,4,pontszoveg,wcslen(pontszoveg));
                WCHAR jatpontjai[3];
                _itow(jatekospontjai,jatpontjai,10);
                TextOut(Memhdc,80,4+28,jatpontjai,wcslen(jatpontjai));
                static const WCHAR uaszoveg[]= L"ZEMANYAG:";
                TextOut(Memhdc,ablakszel/2,4,uaszoveg,wcslen(uaszoveg));
                Rectangle(Memhdc,ablakszel/2,4+28,ablakszel/2+jatuzemanyaga,4+28+8);
            };
            BitBlt(grafikakezelo, 0, 0, ablakszel, ablakmag, Memhdc, 0, 0, SRCCOPY);
            DeleteObject(Membitmap);
            DeleteDC(Memhdc);

            EndPaint(hwnd, &ps);
        break;
        /*case WM_SIZE:
            ablakszel = LOWORD(lParam);
            ablakmag = HIWORD(lParam);

            jatekos.xhely *= (static_cast<double>(ablakszel)/regiablakszel);
            jatekos.yhely *= (static_cast<double>(ablakmag)/regiablakmag);

            regiablakszel = ablakszel;
            regiablakmag = ablakmag;
        break;*/
        case WM_KEYDOWN:
            if (jatekallapota == 1) {
                switch (wParam)
                {
                    case VK_CONTROL: if (urhajoletezik == true) {
                        if (jatekos.alkepe != 0) {
                            PlaySound(TEXT("loveshang.wav"), NULL, SND_FILENAME | SND_ASYNC);
                            if (jatekos.iranya == 0) {
                                jatlovedekei.push_back(JatUrhLov(jatekos.xhely+30,jatekos.yhely+10,jatekos.iranya));
                            }
                            else {
                                jatlovedekei.push_back(JatUrhLov(jatekos.xhely-30,jatekos.yhely+10,jatekos.iranya));
                            };
                        };
                    };
                    break;
                    case VK_ESCAPE:
                                    int kilepesablaka = MessageBoxA(
                                        NULL,
                                        "Biztosan ki akarsz lepni?",
                                        "Megerosites",
                                        MB_ICONWARNING | MB_YESNO
                                    );
                                    switch (kilepesablaka) {
                                        case IDYES: DestroyWindow(hwnd); break;
                                    };
                    break;
                };
            }
            else {
                if (wParam==VK_ESCAPE) {
                    DestroyWindow(hwnd);
                }
                else {
                    jatekallapota = 1;
                    urhajoletezik=true;
                    SetTimer(hwnd,alkepvalto,250,NULL);
                    SetTimer(hwnd,ellcsinalo,500,NULL);
                    jatuzemanyaga = 100;
                    jatekospontjai = 0;
                    jatekoseletei = 3;
                    jatekos.xhely = ablakszel/2;
                    jatekos.yhely = ablakmag/2;
                    for (int i=0; i<csillagok.size(); i++)
                    {
                        csillagok[i].xhely = rand()%ablakszel;
                        csillagok[i].yhely = rand()%ablakmag;
                    };
                    GetObject(aknakkepe, sizeof(bitmapkep), &bitmapkep);
                    for (int i=0; i<2; i++)
                    {
                        aknak.push_back(AknakKeppel(100,(i*100)+100,bitmapkep.bmWidth,bitmapkep.bmHeight));
                    };
                    GetObject(ufokepe, sizeof(ufobitmapkep), &ufobitmapkep);
                    ellensegek.push_back(Ellenseg(-ufobitmapkep.bmWidth,ablakmag/2,0,0,ufobitmapkep.bmWidth,ufobitmapkep.bmHeight));
                    GetObject(aknasufokepe1, sizeof(aknasufobitmapkep), &aknasufobitmapkep);
                    ellensegek.push_back(Ellenseg(ablakszel+aknasufobitmapkep.bmWidth,rand()%ablakmag-aknasufobitmapkep.bmHeight,1,1,aknasufobitmapkep.bmWidth,aknasufobitmapkep.bmHeight));
                };
            };
        break;
        case WM_TIMER:
            switch (wParam)
            {
                case idozito: if (urhajoletezik == true) {
                    GetWindowRect(hwnd, &ablak);
                    //W(0x57)-A(0x41)-S(0x53)-D(0x44)
                    if (GetAsyncKeyState(VK_UP) && jatuzemanyaga > 0) {
                        for (int cs=0; cs<csillagok.size(); cs++) {
                            csillagok[cs].yhely += 2;
                            if (csillagok[cs].yhely > ablakmag) {
                                csillagok[cs].yhely = 1;
                                csillagok[cs].xhely = rand()%ablakszel;
                            };
                        };
                        if (jatekos.yhely-4>0) jatekos.yhely-=4;
                        if (levonhatjatuzemanyagot == true) {
                            jatuzemanyaga -= 1;
                            levonhatjatuzemanyagot = false;
                            SetTimer(hwnd,jatuzemanyaglevono,500,NULL);
                        };
                    };
                    if (GetAsyncKeyState(VK_LEFT)) {
                        if (jatekos.xhely-4>0) {
                            if (jatekos.iranya == 180 && jatuzemanyaga > 0) {
                                for (int cs=0; cs<csillagok.size(); cs++) {
                                    csillagok[cs].xhely += 2;
                                    if (csillagok[cs].xhely > ablakszel) {
                                        csillagok[cs].xhely = 1;
                                        csillagok[cs].yhely = rand()%(ablakmag-8)+8;
                                    };
                                };
                                jatekos.xhely-=4;
                                if (levonhatjatuzemanyagot == true) {
                                    jatuzemanyaga -= 1;
                                    levonhatjatuzemanyagot = false;
                                    SetTimer(hwnd,jatuzemanyaglevono,500,NULL);
                                };
                            }
                            else jatekos.mitcsinal = 1; //Balra fordul
                        };
                    };
                    if (GetAsyncKeyState(VK_DOWN) && jatuzemanyaga > 0) {
                         for (int cs=0; cs<csillagok.size(); cs++) {
                            csillagok[cs].yhely -= 2;
                            if (csillagok[cs].yhely < 0) {
                                csillagok[cs].yhely = ablakmag-1;
                                csillagok[cs].xhely = rand()%ablakszel;
                            };
                        };
                        if (jatekos.yhely+4+40<(ablak.bottom-ablak.top)) jatekos.yhely+=4;
                        if (levonhatjatuzemanyagot == true) {
                            jatuzemanyaga -= 1;
                            levonhatjatuzemanyagot = false;
                            SetTimer(hwnd,jatuzemanyaglevono,500,NULL);
                        };
                    };
                    if (GetAsyncKeyState(VK_RIGHT)) {
                        if (jatekos.xhely+4+40<(ablak.right-ablak.left)) {
                            if (jatekos.iranya == 0 && jatuzemanyaga > 0) {
                                for (int cs=0; cs<csillagok.size(); cs++) {
                                    csillagok[cs].xhely -= 2;
                                    if (csillagok[cs].xhely < 0) {
                                        csillagok[cs].xhely = ablakszel-1;
                                        csillagok[cs].yhely = rand()%(ablakmag-8)+8;
                                    };
                                };
                                jatekos.xhely+=4;
                                if (levonhatjatuzemanyagot == true) {
                                    jatuzemanyaga -= 1;
                                    levonhatjatuzemanyagot = false;
                                    SetTimer(hwnd,jatuzemanyaglevono,500,NULL);
                                };
                            }
                            else jatekos.mitcsinal = -1; //Jobbra fordul
                        };
                    };
                };
                InvalidateRect(hwnd, NULL, true);
                break;
                case jatuzemanyaglevono: levonhatjatuzemanyagot = true;
                break;
                case alkepvalto:
                    if (urhajoletezik == true) {
                        switch (jatekos.mitcsinal) {
                            case 0: jatekos.alkepe*=-1; //Semmit:
                            break;
                            case 1: //Balra fordul:
                                if (jatekos.alkepe == 0) {
                                    jatekos.iranya = 180;
                                    jatekos.alkepe = 1;
                                    jatekos.mitcsinal = 0;
                                } else jatekos.alkepe = 0;
                            break;
                            case -1: //Jobbra fordul:
                                if (jatekos.alkepe == 0) {
                                    jatekos.iranya = 0;
                                    jatekos.alkepe = -1;
                                    jatekos.mitcsinal = 0;
                                } else jatekos.alkepe = 0;
                            break;
                        };
                    };
                break;
                case jatekosvisszater: KillTimer(hwnd,jatekosvisszater);
                    if (jatekoseletei > 0) {
                        urhajoletezik = true;
                        jatuzemanyaga = 100;
                        jatekospontjai = 0;
                    }
                    else {
                        int kilepesablaka = MessageBoxA(
                                        NULL,
                                        "Elfogytak az eleteid. Ujrakezded a jatekot?",
                                        "Megerosites",
                                        MB_ICONWARNING | MB_YESNO
                                    );
                                    switch (kilepesablaka) {
                                        case IDYES: palyatorles();
                                            jatekallapota = 1;
                                            urhajoletezik=true;
                                            jatuzemanyaga = 100;
                                            jatekospontjai = 0;
                                            jatekoseletei = 3;
                                            jatekos.xhely = ablakszel/2;
                                            jatekos.yhely = ablakmag/2;
                                            for (int i=0; i<22; i++)
                                            {
                                                csillagok.push_back(Csillag(rand()%ablakszel,rand()%ablakmag));
                                            };
                                            GetObject(aknakkepe, sizeof(bitmapkep), &bitmapkep);
                                            for (int i=0; i<2; i++)
                                            {
                                                aknak.push_back(AknakKeppel(100,(i*100)+100,bitmapkep.bmWidth,bitmapkep.bmHeight));
                                            };
                                            GetObject(ufokepe, sizeof(ufobitmapkep), &ufobitmapkep);
                                            ellensegek.push_back(Ellenseg(-ufobitmapkep.bmWidth,ablakmag/2,0,0,ufobitmapkep.bmWidth,ufobitmapkep.bmHeight));
                                            GetObject(aknasufokepe1, sizeof(aknasufobitmapkep), &aknasufobitmapkep);
                                            ellensegek.push_back(Ellenseg(ablakszel+aknasufobitmapkep.bmWidth,rand()%ablakmag-aknasufobitmapkep.bmHeight,1,1,aknasufobitmapkep.bmWidth,aknasufobitmapkep.bmHeight));
                                        break;
                                        case IDNO: palyatorles(); jatekallapota = 0;
                                            KillTimer(hwnd,alkepvalto);
                                            KillTimer(hwnd,ellcsinalo);
                                            for (int i=0; i<22; i++)
                                            {
                                                csillagok.push_back(Csillag(ablakszel/2,ablakmag/2));
                                            };
                                        break;
                                    };
                    };
                break;
                case ellcsinalo: if (rand()%8==1) {
                    switch (rand()%5) {
                        case 0:
                            GetObject(ufokepe, sizeof(ufobitmapkep), &ufobitmapkep);
                            if (rand()%2 == 1)
                                ellensegek.push_back(Ellenseg(-ufobitmapkep.bmWidth,rand()%(ablakmag-ufobitmapkep.bmHeight),0,0,ufobitmapkep.bmWidth,ufobitmapkep.bmHeight));
                            else
                                ellensegek.push_back(Ellenseg(ablakszel+ufobitmapkep.bmWidth,rand()%(ablakmag-ufobitmapkep.bmHeight),0,1,ufobitmapkep.bmWidth,ufobitmapkep.bmHeight));
                        break;
                        case 1:
                            GetObject(aknasufokepe1, sizeof(aknasufobitmapkep), &aknasufobitmapkep);
                            if (rand()%2 == 1)
                                ellensegek.push_back(Ellenseg(ablakszel+aknasufobitmapkep.bmWidth,rand()%(ablakmag-aknasufobitmapkep.bmHeight),1,0,aknasufobitmapkep.bmWidth,aknasufobitmapkep.bmHeight));
                            else
                                ellensegek.push_back(Ellenseg(ablakszel+aknasufobitmapkep.bmWidth,rand()%(ablakmag-aknasufobitmapkep.bmHeight),1,1,aknasufobitmapkep.bmWidth,aknasufobitmapkep.bmHeight));
                        break;
                        case 2:
                            GetObject(meduzakepe1, sizeof(meduzabitmapkep), &meduzabitmapkep);
                            if (rand()%2 == 1)
                                ellensegek.push_back(Ellenseg(ablakszel+meduzabitmapkep.bmWidth,rand()%(ablakmag-meduzabitmapkep.bmHeight),2,0,meduzabitmapkep.bmWidth,meduzabitmapkep.bmHeight));
                            else
                                ellensegek.push_back(Ellenseg(ablakszel+meduzabitmapkep.bmWidth,rand()%(ablakmag-meduzabitmapkep.bmHeight),2,1,meduzabitmapkep.bmWidth,meduzabitmapkep.bmHeight));
                        break;
                    };
                };
                break;
            };
        break;
        case WM_DESTROY:
            KillTimer(hwnd,idozito);
            KillTimer(hwnd,alkepvalto);
            KillTimer(hwnd,ellcsinalo);
            KillTimer(hwnd,jatekosvisszater);
            KillTimer(hwnd,jatuzemanyaglevono);
            ReleaseDC(hwnd,grafikakezelo);
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
